//+------------------------------------------------------------------+
//|                                                   ZZTemplate.mq4 |
//|                                                           Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+
//#property copyright ""
//#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 2

//extern int H = 33;
extern int  MinBars = 0;

//double dH;
bool UpZ;
double TempMax,TempMin;
int TempMaxBar,TempMinBar;
double CurMax,CurMin;
int CurMaxBar,CurMinBar;

int PreBars;
datetime BarTime;
int StartPos;
int pos;

double ZZ[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
  SetIndexBuffer(0,ZZ);
  SetIndexStyle(0,DRAW_SECTION,EMPTY,2);
  SetIndexEmptyValue(0,0.0);
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator reset function                                  |
//+------------------------------------------------------------------+
int Reset() {
  if (MinBars == 0) MinBars = Bars-1;
  StartPos = MinBars;
  PreBars = 0;
  BarTime = 0;
//  dH = H*Point;
  UpZ = true;
  TempMaxBar = Bars-StartPos;
  TempMinBar = Bars-StartPos;
  TempMax = High[StartPos];
  TempMin = Low[StartPos];
  StartPos++;
  return(StartPos);
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
double SwitchLevel() {
  double SwLvl;
//       
//--
//  if (UpZ) SwLvl = TempMax - dH;
//  else SwLvl = TempMin + dH;
//--
  return(SwLvl);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  int i;
  int TempExtPos;
//      
  if (Bars == PreBars) return(0);  
//  ,     
  if (Bars < MinBars) {
    Alert(":    ");
    return(0);
  }  
//      ,    
  if (Bars-PreBars == 1 && BarTime==Time[1]) StartPos = 1;
//       Reset()   
  else StartPos = Reset();
//   
  PreBars = Bars;  
  BarTime=Time[0];
//   
  for (pos=StartPos;pos>0;pos--) {
//       
    ZZ[pos] = 0;
//       
//     
    if (UpZ) {
// ,     
      if (High[pos]>TempMax) {
//  ,   
        TempMax = High[pos];
        TempMaxBar = Bars-pos;  //     
      } else {
//  ,      
        if (Low[pos]<SwitchLevel()) {
//  ,  
          CurMax = TempMax;
          CurMaxBar = TempMaxBar;
//   
          ZZ[Bars-CurMaxBar]=CurMax;  //     
//   
          UpZ = false;
//          TempMin = Low[pos];
//          TempMinBar = Bars-pos;  //     
          TempMinBar = CurMaxBar+1;
          TempExtPos = Bars - TempMinBar;  //     
          TempMin = Low[TempExtPos];
          for (i=TempExtPos-1;i>=pos;i--) {
            if (Low[i]<TempMin) {
              TempMin = Low[i];
              TempMinBar = Bars-i;  //     
            }
          }
        }
      }
    }  else {
//     
// ,     
      if (Low[pos]<TempMin) {
//  ,   
        TempMin = Low[pos];
        TempMinBar = Bars-pos;  //     
      } else {
//  ,      
        if (High[pos]>SwitchLevel()) {
//  ,  
          CurMin = TempMin;
          CurMinBar = TempMinBar;
//   
          ZZ[Bars-CurMinBar]=CurMin;  //     
//   
          UpZ = true;
//          TempMax = High[pos];
//          TempMaxBar = Bars-pos;  //     
          TempMaxBar = CurMinBar+1;
          TempExtPos = Bars - TempMaxBar;  //     
          TempMax = High[TempExtPos];
          for (i=TempExtPos-1;i>=pos;i--) {
            if (High[i]>TempMax) {
              TempMax = High[i];
              TempMaxBar = Bars-i;  //     
            }
          }
        }
      }
    }
//    
//           
  }  //  pos=StartPos;pos>0;pos--) 
  return(0);
}